diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/examples/zigbee-nwk-routing-grid.cc ns-3.44/src/zigbee/examples/zigbee-nwk-routing-grid.cc
--- ns-3.43/src/zigbee/examples/zigbee-nwk-routing-grid.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/examples/zigbee-nwk-routing-grid.cc	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,365 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+/**
+ *  Many to one routing example in a grid topology.
+ *
+ *  Topology:
+ *
+ *  Grid Topology: 50 nodes separated by 30 m around them, 20 nodes per row for
+ *  the first two rows
+ *
+ *      (Node 0)
+ *         |
+ *         v
+ *         * * * * * * * * * * * * * * * * * * * *
+ *         * * * * * * * * * * * * * * * * * * * *
+ *         * * * * * * * * * *  <--- (Node 49)
+ *
+ *  This example is a more complex version of zigbee-nwk-routing.cc.
+ *  The top left node is the coordinator while the rest of the nodes join
+ *  the network sequentially and they initiate as routers.
+ *
+ *  After all devices join the network a MANY-TO-ONE route discovery is issued
+ *  to create the routes from all the nodes towards the concentrator (Node 0).
+ *
+ *  At the end of the example, the contents of all the tables (Neighbor, Discovery, routing)
+ *  in the source node (Node 49) are displayed.
+ *
+ *  Also the trace route from Node 49 to Node 0 is displayed.
+ *  No data is transmitted in this example.
+ *  All devices are routers excepting the first node which is the coordinator.
+ *
+ */
+
+#include "ns3/core-module.h"
+#include "ns3/log.h"
+#include "ns3/lr-wpan-module.h"
+#include "ns3/mobility-module.h"
+#include "ns3/packet.h"
+#include "ns3/propagation-delay-model.h"
+#include "ns3/propagation-loss-model.h"
+#include "ns3/simulator.h"
+#include "ns3/single-model-spectrum-channel.h"
+#include "ns3/zigbee-module.h"
+
+#include <iostream>
+
+using namespace ns3;
+using namespace ns3::lrwpan;
+using namespace ns3::zigbee;
+
+ZigbeeStackContainer zigbeeStacks;
+
+static void
+TraceRoute(Mac16Address src, Mac16Address dst)
+{
+    std::cout << "\n";
+    std::cout << "Traceroute to destination [" << dst << "] (Time: " << Simulator::Now().As(Time::S)
+              << "):\n";
+    Mac16Address target = src;
+    uint32_t count = 1;
+    while (target != Mac16Address("FF:FF") && target != dst)
+    {
+        Ptr<ZigbeeStack> zstack;
+
+        for (auto i = zigbeeStacks.Begin(); i != zigbeeStacks.End(); i++)
+        {
+            zstack = *i;
+            if (zstack->GetNwk()->GetNetworkAddress() == target)
+            {
+                break;
+            }
+        }
+
+        bool neighbor = false;
+        target = zstack->GetNwk()->FindRoute(dst, neighbor);
+        if (target == Mac16Address("FF:FF"))
+        {
+            std::cout << count << ". Node " << zstack->GetNode()->GetId() << " ["
+                      << zstack->GetNwk()->GetNetworkAddress() << " | "
+                      << zstack->GetNwk()->GetIeeeAddress() << "]: "
+                      << " Destination Unreachable\n";
+        }
+        else
+        {
+            std::cout << count << ". Node " << zstack->GetNode()->GetId() << " ["
+                      << zstack->GetNwk()->GetNetworkAddress() << " | "
+                      << zstack->GetNwk()->GetIeeeAddress() << "]: "
+                      << "NextHop [" << target << "] ";
+            if (neighbor)
+            {
+                std::cout << "(*Neighbor)\n";
+            }
+            else
+            {
+                std::cout << "\n";
+            }
+            count++;
+        }
+    }
+    std::cout << "\n";
+}
+
+static void
+CreateManyToOneRoutes(Ptr<ZigbeeStack> zigbeeStackConcentrator, Ptr<ZigbeeStack> zigbeeStackSrc)
+{
+    // Generate all the routes to the concentrator device
+    NlmeRouteDiscoveryRequestParams routeDiscParams;
+    routeDiscParams.m_dstAddrMode = NO_ADDRESS;
+    Simulator::ScheduleNow(&ZigbeeNwk::NlmeRouteDiscoveryRequest,
+                           zigbeeStackConcentrator->GetNwk(),
+                           routeDiscParams);
+
+    // Give a few seconds to allow the creation of the route and
+    // then print the route trace and tables from the source
+    Simulator::Schedule(Seconds(3),
+                        &TraceRoute,
+                        zigbeeStackSrc->GetNwk()->GetNetworkAddress(),
+                        zigbeeStackConcentrator->GetNwk()->GetNetworkAddress());
+
+    // Print the content of the source device tables (Neighbor, Discovery, Routing)
+    Ptr<OutputStreamWrapper> stream = Create<OutputStreamWrapper>(&std::cout);
+    Simulator::Schedule(Seconds(4),
+                        &ZigbeeNwk::PrintNeighborTable,
+                        zigbeeStackSrc->GetNwk(),
+                        stream);
+
+    Simulator::Schedule(Seconds(4),
+                        &ZigbeeNwk::PrintRoutingTable,
+                        zigbeeStackSrc->GetNwk(),
+                        stream);
+
+    Simulator::Schedule(Seconds(4),
+                        &ZigbeeNwk::PrintRouteDiscoveryTable,
+                        zigbeeStackSrc->GetNwk(),
+                        stream);
+}
+
+static void
+NwkDataIndication(Ptr<ZigbeeStack> stack, NldeDataIndicationParams params, Ptr<Packet> p)
+{
+    std::cout << "Received packet of size " << p->GetSize() << "\n";
+}
+
+static void
+NwkNetworkFormationConfirm(Ptr<ZigbeeStack> stack, NlmeNetworkFormationConfirmParams params)
+{
+    std::cout << "NlmeNetworkFormationConfirmStatus = " << params.m_status << "\n";
+}
+
+static void
+NwkNetworkDiscoveryConfirm(Ptr<ZigbeeStack> stack, NlmeNetworkDiscoveryConfirmParams params)
+{
+    // See Zigbee Specification r22.1.0, 3.6.1.4.1
+    // This method implements a simplistic version of the method implemented
+    // in a zigbee APL layer. In this layer a candidate Extended PAN Id must
+    // be selected and a NLME-JOIN.request must be issued.
+
+    if (params.m_status == NwkStatus::SUCCESS)
+    {
+        std::cout << "    Network discovery confirm Received. Networks found "
+                  << "(" << params.m_netDescList.size() << ")\n";
+
+        for (const auto& netDescriptor : params.m_netDescList)
+        {
+            std::cout << "      ExtPanID: 0x" << std::hex << netDescriptor.m_extPanId << std::dec
+                      << "\n"
+                      << "      CH:  " << static_cast<uint32_t>(netDescriptor.m_logCh) << std::hex
+                      << "\n"
+                      << "      Pan Id: 0x" << netDescriptor.m_panId << std::hex << "\n"
+                      << "      stackprofile: " << std::dec
+                      << static_cast<uint32_t>(netDescriptor.m_stackProfile) << "\n"
+                      << "      ----------------\n ";
+        }
+
+        NlmeJoinRequestParams joinParams;
+
+        zigbee::CapabilityInformation capaInfo;
+        capaInfo.SetDeviceType(ROUTER);
+        capaInfo.SetAllocateAddrOn(true);
+
+        joinParams.m_rejoinNetwork = zigbee::JoiningMethod::ASSOCIATION;
+        joinParams.m_capabilityInfo = capaInfo.GetCapability();
+        joinParams.m_extendedPanId = params.m_netDescList[0].m_extPanId;
+
+        Simulator::ScheduleNow(&ZigbeeNwk::NlmeJoinRequest, stack->GetNwk(), joinParams);
+    }
+    else
+    {
+        std::cout << " WARNING: Unable to discover networks | status: " << params.m_status << "\n";
+    }
+}
+
+static void
+NwkJoinConfirm(Ptr<ZigbeeStack> stack, NlmeJoinConfirmParams params)
+{
+    if (params.m_status == NwkStatus::SUCCESS)
+    {
+        std::cout << Simulator::Now().As(Time::S)
+                  << " The device joined the network SUCCESSFULLY with short address [" << std::hex
+                  << params.m_networkAddress << "] on the Extended PAN Id: " << std::hex
+                  << params.m_extendedPanId << "\n"
+                  << std::dec;
+
+        // 3 - After dev  is associated, it should be started as a router
+        //     (i.e. it becomes able to accept request from other devices to join the network)
+        NlmeStartRouterRequestParams startRouterParams;
+        Simulator::ScheduleNow(&ZigbeeNwk::NlmeStartRouterRequest,
+                               stack->GetNwk(),
+                               startRouterParams);
+    }
+    else
+    {
+        std::cout << Simulator::Now().As(Time::S)
+                  << " The device FAILED to join the network with status " << params.m_status
+                  << "\n";
+    }
+}
+
+static void
+NwkRouteDiscoveryConfirm(Ptr<ZigbeeStack> stack, NlmeRouteDiscoveryConfirmParams params)
+{
+    std::cout << "NlmeRouteDiscoveryConfirmStatus = " << params.m_status << "\n";
+}
+
+int
+main(int argc, char* argv[])
+{
+    LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC | LOG_PREFIX_NODE));
+    // Enable logs for further details
+    // LogComponentEnable("ZigbeeNwk", LOG_LEVEL_DEBUG);
+
+    NodeContainer nodes;
+    nodes.Create(50);
+
+    MobilityHelper mobility;
+    mobility.SetPositionAllocator("ns3::GridPositionAllocator",
+                                  "MinX",
+                                  DoubleValue(0.0),
+                                  "MinY",
+                                  DoubleValue(0.0),
+                                  "DeltaX",
+                                  DoubleValue(30.0),
+                                  "DeltaY",
+                                  DoubleValue(30.0),
+                                  "GridWidth",
+                                  UintegerValue(20),
+                                  "LayoutType",
+                                  StringValue("RowFirst"));
+
+    mobility.Install(nodes);
+
+    Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel>();
+    Ptr<LogDistancePropagationLossModel> propModel =
+        CreateObject<LogDistancePropagationLossModel>();
+    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
+        CreateObject<ConstantSpeedPropagationDelayModel>();
+
+    channel->AddPropagationLossModel(propModel);
+    channel->SetPropagationDelayModel(delayModel);
+
+    LrWpanHelper lrWpanHelper;
+    lrWpanHelper.SetChannel(channel);
+
+    NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
+
+    // Set the extended address to all devices (EUI-64)
+    // Device must ALWAYS have IEEE Address (Extended address) assigned.
+    // Network address (short address) are assigned by the the JOIN mechanism
+    // In this case we use the helper to assign a sequential extended addresses
+    // to all nodes in the simulation.
+    lrWpanHelper.SetExtendedAddresses(lrwpanDevices);
+
+    ZigbeeHelper zigbeeHelper;
+    zigbeeStacks = zigbeeHelper.Install(lrwpanDevices);
+
+    // NWK callbacks hooks
+    // These hooks are usually directly connected to the APS layer
+    // In this case, there is no APS layer, therefore, we connect the event outputs
+    // of all devices directly to our static functions in this example.
+    for (auto i = zigbeeStacks.Begin(); i != zigbeeStacks.End(); i++)
+    {
+        Ptr<ZigbeeStack> zstack = *i;
+        // NLME-NETWORK-FORMATION.Confirm
+        zstack->GetNwk()->SetNlmeNetworkFormationConfirmCallback(
+            MakeBoundCallback(&NwkNetworkFormationConfirm, zstack));
+        // NLDE-DATA.Indication
+        zstack->GetNwk()->SetNldeDataIndicationCallback(
+            MakeBoundCallback(&NwkDataIndication, zstack));
+        // NLDE-NETWORK-DISCOVERY.Confirm
+        zstack->GetNwk()->SetNlmeNetworkDiscoveryConfirmCallback(
+            MakeBoundCallback(&NwkNetworkDiscoveryConfirm, zstack));
+        // NLME-JOIN.Confirm
+        zstack->GetNwk()->SetNlmeJoinConfirmCallback(MakeBoundCallback(&NwkJoinConfirm, zstack));
+        // NLME-ROUTE-DISCOVERY.Confirm
+        zstack->GetNwk()->SetNlmeRouteDiscoveryConfirmCallback(
+            MakeBoundCallback(&NwkRouteDiscoveryConfirm, zstack));
+    }
+
+    for (auto i = zigbeeStacks.Begin(); i != zigbeeStacks.End(); i++)
+    {
+        int index = std::distance(zigbeeStacks.Begin(), i);
+        Ptr<ZigbeeStack> zstack = *i;
+
+        // Assign streams to the zigbee stacks based on the index to obtain
+        // reprodusable results from random events occurring inside the stack.
+        // For example, to obtain the same assigned short address in each device.
+        zstack->GetNwk()->AssignStreams(index);
+
+        if (index == 0)
+        {
+            // 1 - Initiate the Zigbee coordinator, start the network
+            // ALL_CHANNELS = 0x07FFF800 (Channels 11~26)
+            NlmeNetworkFormationRequestParams netFormParams;
+            netFormParams.m_scanChannelList.channelPageCount = 1;
+            netFormParams.m_scanChannelList.channelsField[0] = ALL_CHANNELS;
+            netFormParams.m_scanDuration = 0;
+            netFormParams.m_superFrameOrder = 15;
+            netFormParams.m_beaconOrder = 15;
+
+            Simulator::ScheduleWithContext(zstack->GetNode()->GetId(),
+                                           MilliSeconds(index * 500),
+                                           &ZigbeeNwk::NlmeNetworkFormationRequest,
+                                           zstack->GetNwk(),
+                                           netFormParams);
+        }
+        else
+        {
+            // 2- Let devices discovery the coordinator or routers and join the network, after
+            //    this, it will become router itself(call to NLME-START-ROUTER.request). We
+            //    continue doing the same with the rest of the devices which will discover the
+            //    previously added routers and join the network
+            NlmeNetworkDiscoveryRequestParams netDiscParams;
+            netDiscParams.m_scanChannelList.channelPageCount = 1;
+            netDiscParams.m_scanChannelList.channelsField[0] = 0x00007800; // BitMap: Channels 11~14
+            netDiscParams.m_scanDuration = 0;
+
+            Simulator::ScheduleWithContext(zstack->GetNode()->GetId(),
+                                           Seconds(2 + index * 10),
+                                           &ZigbeeNwk::NlmeNetworkDiscoveryRequest,
+                                           zstack->GetNwk(),
+                                           netDiscParams);
+        }
+    }
+
+    // 3- Create the routes towards the concentrator (Node 0)
+    // Print the trace route from Node 49 to the concentrator (Node 0)
+    // Print the contents of tables in the source of trace (Node 49)
+    Simulator::Schedule(Seconds(500),
+                        &CreateManyToOneRoutes,
+                        zigbeeStacks.Get(0),
+                        zigbeeStacks.Get(49));
+
+    Simulator::Stop(Seconds(1500));
+    Simulator::Run();
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/helper/zigbee-helper.cc ns-3.44/src/zigbee/helper/zigbee-helper.cc
--- ns-3.43/src/zigbee/helper/zigbee-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/helper/zigbee-helper.cc	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-helper.h"
+
+#include "ns3/log.h"
+#include "ns3/names.h"
+#include "ns3/net-device.h"
+#include "ns3/node.h"
+#include "ns3/zigbee-stack.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("ZigbeeHelper");
+
+ZigbeeHelper::ZigbeeHelper()
+{
+    NS_LOG_FUNCTION(this);
+    m_stackFactory.SetTypeId("ns3::zigbee::ZigbeeStack");
+}
+
+void
+ZigbeeHelper::SetDeviceAttribute(std::string n1, const AttributeValue& v1)
+{
+    NS_LOG_FUNCTION(this);
+    m_stackFactory.Set(n1, v1);
+}
+
+zigbee::ZigbeeStackContainer
+ZigbeeHelper::Install(const NetDeviceContainer c)
+{
+    NS_LOG_FUNCTION(this);
+
+    zigbee::ZigbeeStackContainer zigbeeStackContainer;
+
+    for (uint32_t i = 0; i < c.GetN(); ++i)
+    {
+        Ptr<NetDevice> device = c.Get(i);
+
+        NS_ASSERT_MSG(device, "NetDevice not found in the node " << i);
+
+        NS_LOG_LOGIC("Installing Zigbee on node " << device->GetNode()->GetId());
+
+        Ptr<zigbee::ZigbeeStack> zigbeeStack = m_stackFactory.Create<zigbee::ZigbeeStack>();
+        zigbeeStackContainer.Add(zigbeeStack);
+        device->GetNode()->AggregateObject(zigbeeStack);
+        zigbeeStack->SetNetDevice(device);
+    }
+    return zigbeeStackContainer;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/helper/zigbee-helper.h ns-3.44/src/zigbee/helper/zigbee-helper.h
--- ns-3.43/src/zigbee/helper/zigbee-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/helper/zigbee-helper.h	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2023 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_HELPER_H
+#define ZIGBEE_HELPER_H
+
+#include "zigbee-stack-container.h"
+
+#include "ns3/net-device-container.h"
+#include "ns3/object-factory.h"
+
+#include <string>
+
+namespace ns3
+{
+
+class Node;
+class AttributeValue;
+class Time;
+
+/**
+ * @ingroup zigbee
+ *
+ *  Setup a Zigbee stack to be used with LrWpanNetDevice.
+ */
+class ZigbeeHelper
+{
+  public:
+    /*
+     * Construct a ZigbeeHelper
+     */
+    ZigbeeHelper();
+    /**
+     * Set an attribute on each ns3::ZigbeeStack created by
+     * ZigbeeHelper::Install.
+     *
+     * @param n1 [in] The name of the attribute to set.
+     * @param v1 [in] The value of the attribute to set.
+     */
+    void SetDeviceAttribute(std::string n1, const AttributeValue& v1);
+
+    /**
+     * Install the Zigbee stack on top of an existing LrWpanNetDevice.
+     *
+     * This function requires a set of properly configured LrWpanNetDevices
+     * passed in as the parameter "c". After the installation,
+     * the set Zigbee stack contains the upper layers that communicate
+     * directly with the application.
+     *
+     * Note that Zigbee is specific designed to be used on top of
+     * LrWpanDevice (IEEE 802.15.4).
+     * Any other protocol will be discarded by Zigbee.
+     *
+     *
+     * @param [in] c The NetDevice container with LrWpanNetDevices.
+     * @return A container with the newly created ZigbeeStacks.
+     */
+    zigbee::ZigbeeStackContainer Install(NetDeviceContainer c);
+
+    /**
+     * Assign a fixed random variable stream number to the random variables
+     * used by this model. Return the number of streams (possibly zero) that
+     * have been assigned. The Install() method should have previously been
+     * called by the user.
+     *
+     * @param [in] c NetDeviceContainer of the set of net devices for which the
+     *          ZigbeeStack should be modified to use a fixed stream.
+     * @param [in] stream First stream index to use.
+     * @return The number of stream indices assigned by this helper.
+     */
+    int64_t AssignStreams(NetDeviceContainer c, int64_t stream);
+
+  private:
+    ObjectFactory m_stackFactory; //!< Zigbee stack object factory.
+};
+
+} // namespace ns3
+
+#endif /* ZIGBEE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/helper/zigbee-stack-container.cc ns-3.44/src/zigbee/helper/zigbee-stack-container.cc
--- ns-3.43/src/zigbee/helper/zigbee-stack-container.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/helper/zigbee-stack-container.cc	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,81 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-stack-container.h"
+
+#include "ns3/names.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+ZigbeeStackContainer::ZigbeeStackContainer()
+{
+}
+
+ZigbeeStackContainer::ZigbeeStackContainer(Ptr<ZigbeeStack> stack)
+{
+    m_stacks.emplace_back(stack);
+}
+
+ZigbeeStackContainer::ZigbeeStackContainer(std::string stackName)
+{
+    Ptr<ZigbeeStack> stack = Names::Find<ZigbeeStack>(stackName);
+    m_stacks.emplace_back(stack);
+}
+
+ZigbeeStackContainer::Iterator
+ZigbeeStackContainer::Begin() const
+{
+    return m_stacks.begin();
+}
+
+ZigbeeStackContainer::Iterator
+ZigbeeStackContainer::End() const
+{
+    return m_stacks.end();
+}
+
+uint32_t
+ZigbeeStackContainer::GetN() const
+{
+    return m_stacks.size();
+}
+
+Ptr<ZigbeeStack>
+ZigbeeStackContainer::Get(uint32_t i) const
+{
+    return m_stacks[i];
+}
+
+void
+ZigbeeStackContainer::Add(ZigbeeStackContainer other)
+{
+    for (auto i = other.Begin(); i != other.End(); i++)
+    {
+        m_stacks.emplace_back(*i);
+    }
+}
+
+void
+ZigbeeStackContainer::Add(Ptr<ZigbeeStack> stack)
+{
+    m_stacks.emplace_back(stack);
+}
+
+void
+ZigbeeStackContainer::Add(std::string stackName)
+{
+    Ptr<ZigbeeStack> stack = Names::Find<ZigbeeStack>(stackName);
+    m_stacks.emplace_back(stack);
+}
+
+} // namespace zigbee
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/helper/zigbee-stack-container.h ns-3.44/src/zigbee/helper/zigbee-stack-container.h
--- ns-3.43/src/zigbee/helper/zigbee-stack-container.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/helper/zigbee-stack-container.h	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,112 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_STACK_CONTAINER_H
+#define ZIGBEE_STACK_CONTAINER_H
+
+#include "ns3/zigbee-stack.h"
+
+#include <stdint.h>
+#include <vector>
+
+namespace ns3
+{
+namespace zigbee
+{
+
+/**
+ * Holds a vector of ns3::ZigbeeStack pointers
+ *
+ * Typically ZigbeeStacks are installed on top of a pre-existing NetDevice
+ * (an LrWpanNetDevice) which on itself has already being aggregated to a node.
+ * A ZigbeeHelper Install method takes a LrWpanNetDeviceContainer.
+ * For each of the LrWpanNetDevice in the LrWpanNetDeviceContainer
+ * the helper will instantiate a ZigbeeStack, connect the necessary hooks between
+ * the MAC (LrWpanMac) and the NWK (ZigbeeNwk) and install it to the node.
+ * For each of these ZigbeeStacks, the helper also adds the ZigbeeStack into a Container
+ * for later use by the caller. This is that container used to hold the Ptr<ZigbeeStack> which are
+ * instantiated by the ZigbeeHelper.
+ */
+class ZigbeeStackContainer
+{
+  public:
+    typedef std::vector<Ptr<ZigbeeStack>>::const_iterator
+        Iterator; //!< The iterator used in this Container
+
+    /**
+     * The default constructor, create an empty ZigbeeStackContainer
+     */
+    ZigbeeStackContainer();
+    /**
+     * Create a ZigbeeStackContainer with exactly one ZigbeeStack that has previously
+     * been instantiated
+     *
+     * @param stack A ZigbeeStack to add to the container
+     */
+    ZigbeeStackContainer(Ptr<ZigbeeStack> stack);
+    /**
+     * Create a ZigbeeStackContainer with exactly one device which has been
+     * previously instantiated and assigned a name using the Object name
+     * service.  This ZigbeeStack is specified by its assigned name.
+     *
+     * @param stackName The name of the ZigbeeStack to add to the container
+     *
+     * Create a ZigbeeStackContainer with exactly one device
+     */
+    ZigbeeStackContainer(std::string stackName);
+    /**
+     * Get and iterator which refers to the first ZigbeeStack in the container.
+     * @return An iterator referring to the first ZigbeeStack in the container.
+     */
+    Iterator Begin() const;
+    /**
+     * Get an iterator which indicates past the last ZigbeeStack in the container.
+     * @return An iterator referring to the past the last ZigbeeStack in the container.
+     */
+    Iterator End() const;
+    /**
+     * Get the number of stacks present in the stack container.
+     * @return The number of stacks in the container.
+     */
+    uint32_t GetN() const;
+    /**
+     * Get a stack element from the container.
+     * @param i The element number in the container
+     * @return The zigbee stack element matching the i index in the container.
+     */
+    Ptr<ZigbeeStack> Get(uint32_t i) const;
+    /**
+     * Append the contents of another ZigbeeStackContainer to the end of
+     * this container.
+     *
+     * @param other The ZigbeeStackContainer to append.
+     */
+    void Add(ZigbeeStackContainer other);
+    /**
+     * Append a single Ptr<ZigbeeStack> to this container.
+     *
+     * @param stack The Ptr<ZigbeeStack> to append.
+     */
+    void Add(Ptr<ZigbeeStack> stack);
+    /**
+     * Append to this container the single Ptr<ZigbeeStack> referred to
+     * via its object name service registered name.
+     *
+     * @param stackName The name of the ZigbeeStack object to add to the container.
+     */
+    void Add(std::string stackName);
+
+  private:
+    std::vector<Ptr<ZigbeeStack>> m_stacks; //!< ZigbeeStack smart pointers
+};
+
+} // namespace zigbee
+} // namespace ns3
+
+#endif /* ZIGBEE_STACK_CONTAINER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/zigbee/model/zigbee-nwk-fields.cc ns-3.44/src/zigbee/model/zigbee-nwk-fields.cc
--- ns-3.43/src/zigbee/model/zigbee-nwk-fields.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/zigbee/model/zigbee-nwk-fields.cc	2025-03-09 16:55:49.819372700 -0700
@@ -0,0 +1,162 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ *
+ */
+
+#include "zigbee-nwk-fields.h"
+
+#include "ns3/log.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+NS_LOG_COMPONENT_DEFINE("ZigbeeNwkFields");
+
+CapabilityInformation::CapabilityInformation()
+{
+    m_allocateAddr = false;
+    m_deviceType = ROUTER;
+    m_powerSource = OTHER_POWER_SOURCE;
+    m_receiverOnWhenIdle = true;
+    m_securityCapability = false;
+    m_allocateAddr = true;
+}
+
+CapabilityInformation::CapabilityInformation(uint8_t bitmap)
+{
+    SetCapability(bitmap);
+}
+
+uint8_t
+CapabilityInformation::GetCapability() const
+{
+    uint8_t capability;
+
+    capability = m_alternatePanCoord & (0x01);          // Bits 0
+    capability |= ((m_deviceType & 0x01) << 1);         // Bit 1
+    capability |= ((m_powerSource & 0x01) << 2);        // Bit 2
+    capability |= ((m_receiverOnWhenIdle & 0x01) << 3); // Bit 3
+                                                        // Bit 4-5 (Reserved)
+    capability |= ((m_securityCapability & 0x01) << 6); // Bit 6
+    capability |= ((m_allocateAddr & 0x01) << 7);       // Bit 7
+
+    return capability;
+}
+
+bool
+CapabilityInformation::IsAlternatePanCoord() const
+{
+    return m_alternatePanCoord;
+}
+
+MacDeviceType
+CapabilityInformation::GetDeviceType() const
+{
+    return m_deviceType;
+}
+
+PowerSource
+CapabilityInformation::GetPowerSource() const
+{
+    return m_powerSource;
+}
+
+bool
+CapabilityInformation::IsReceiverOnWhenIdle() const
+{
+    return m_receiverOnWhenIdle;
+}
+
+bool
+CapabilityInformation::IsAllocateAddrOn() const
+{
+    return m_allocateAddr;
+}
+
+void
+CapabilityInformation::SetCapability(uint8_t capability)
+{
+    m_alternatePanCoord = (capability) & (0x01);                           // Bit 0
+    m_deviceType = static_cast<MacDeviceType>((capability >> 1) & (0x01)); // Bit 1
+    m_powerSource = static_cast<PowerSource>((capability >> 2) & (0x01));  // Bit 2
+    m_receiverOnWhenIdle = (capability >> 3) & (0x01);                     // Bit 3
+                                                                           // Bit 4-5 (Reserved)
+    m_securityCapability = (capability >> 6) & (0x01);                     // Bit 6
+    m_allocateAddr = (capability >> 7) & (0x01);                           // Bit 7
+}
+
+void
+CapabilityInformation::SetDeviceType(MacDeviceType devType)
+{
+    m_deviceType = devType;
+}
+
+void
+CapabilityInformation::SetPowerSource(PowerSource powerSource)
+{
+    m_powerSource = powerSource;
+}
+
+void
+CapabilityInformation::SetReceiverOnWhenIdle(bool value)
+{
+    m_receiverOnWhenIdle = value;
+}
+
+void
+CapabilityInformation::SetAllocateAddrOn(bool value)
+{
+    m_allocateAddr = value;
+}
+
+SuperframeInformation::SuperframeInformation()
+{
+}
+
+SuperframeInformation::SuperframeInformation(uint16_t bitmap)
+{
+    SetSuperframe(bitmap);
+}
+
+void
+SuperframeInformation::SetSuperframe(uint16_t superFrmSpec)
+{
+    m_sspecBcnOrder = (superFrmSpec) & (0x0F);         // Bits 0-3
+    m_sspecSprFrmOrder = (superFrmSpec >> 4) & (0x0F); // Bits 4-7
+
+    m_sspecPanCoor = (superFrmSpec >> 14) & (0x01);     // Bit 14
+    m_sspecAssocPermit = (superFrmSpec >> 15) & (0x01); // Bit 15
+}
+
+uint8_t
+SuperframeInformation::GetBeaconOrder() const
+{
+    return m_sspecBcnOrder;
+}
+
+uint8_t
+SuperframeInformation::GetFrameOrder() const
+{
+    return m_sspecSprFrmOrder;
+}
+
+bool
+SuperframeInformation::IsPanCoor() const
+{
+    return m_sspecPanCoor;
+}
+
+bool
+SuperframeInformation::IsAssocPermit() const
+{
+    return m_sspecAssocPermit;
+}
+
+} // namespace zigbee
+} // namespace ns3
